subroutine param_AnalPower(AnalPower_par)
  use AnalPower_types
  use sep

  implicit none
  type (AnalPower_param_type) AnalPower_par
  character(len=128) :: tag_name

  integer ::  omp_get_max_threads
  integer n_threads_env,n_threads_init
  integer ierr
  integer n1,n2,n3,n4,n5
  integer, external :: auxpar,getch,fetch,auxin,auxinout,sreed,sseek,auxout
  real o1,o2,o3,o4,o5,d1,d2,d3,d4,d5

  n_threads_init=1

  call from_param('verb',AnalPower_par%verb,.true.)
  call from_param('debug1',AnalPower_par%debug1,.false.)
  call from_param('debug2',AnalPower_par%debug2,.false.)

  call from_param('n_threads',AnalPower_par%n_threads,n_threads_init)
  call from_param('max_memory',AnalPower_par%max_memory,100)

  call from_param('first_adj',AnalPower_par%first_adj,.false.)
  call from_param('first_add',AnalPower_par%first_add,.false.)

  call from_param('two_param',AnalPower_par%two_param,.true.)


  ! checking parameters
  n_threads_env=omp_get_max_threads()
  if(AnalPower_par%n_threads == n_threads_init) then
     AnalPower_par%n_threads=n_threads_env
  else
     if(n_threads_env > AnalPower_par%n_threads) then
        call omp_set_num_threads(AnalPower_par%n_threads)
        write(0,*)'WARNING: overwriting environment variable'
        write(0,*)'AnalPower_par-n_threads=',AnalPower_par%n_threads
     end if
     if(n_threads_env < AnalPower_par%n_threads) then
        write(0,*)'AnalPower_par-n_threads=',AnalPower_par%n_threads
        write(0,*)'OMP_NUM_THREADS=',n_threads_env
        call seperr('ERROR: Asked for more threads than the environment variable allows')
     end if
  end if


    call from_history('esize',AnalPower_par%esize)
    if(AnalPower_par%esize /= 4) call seperr("Input should be real")

    call from_history('n1',AnalPower_par%n1)
    call from_history('n2',AnalPower_par%n2)
    call from_history('n3',AnalPower_par%n3,1)
    call from_history('n4',AnalPower_par%n4,1)
    call from_history('n5',AnalPower_par%n5,1)
    
    call from_history('d1',AnalPower_par%d1)
    call from_history('d2',AnalPower_par%d2)
    call from_history('d3',AnalPower_par%d3,1.)
    call from_history('d4',AnalPower_par%d4,1.)
    call from_history('d5',AnalPower_par%d5,1.)
    
    call from_history('o1',AnalPower_par%o1)
    call from_history('o2',AnalPower_par%o2)
    call from_history('o3',AnalPower_par%o3,0.)
    call from_history('o4',AnalPower_par%o4,0.)
    call from_history('o5',AnalPower_par%o5,0.)

    AnalPower_par%label1="P1"
    call from_history('label1',AnalPower_par%label1,trim(AnalPower_par%label1))
    call to_history('label1',AnalPower_par%label1)
    AnalPower_par%label2="P2"
    call from_history('label2',AnalPower_par%label2,trim(AnalPower_par%label2))
    call to_history('label2',AnalPower_par%label2)
    AnalPower_par%label3="Depth"
    call from_history('label3',AnalPower_par%label3,trim(AnalPower_par%label3))
    call to_history('label3',AnalPower_par%label3)
    AnalPower_par%label4="Mx"
    call from_history('label4',AnalPower_par%label4,trim(AnalPower_par%label4))
    call to_history('label4',AnalPower_par%label4)
    AnalPower_par%label5="My"
    call from_history('label5',AnalPower_par%label5,trim(AnalPower_par%label5))
    call to_history('label5',AnalPower_par%label5)

    AnalPower_par%n1_out=AnalPower_par%n1
    AnalPower_par%n2_out=AnalPower_par%n2
    AnalPower_par%n3_out=AnalPower_par%n3
    AnalPower_par%n4_out=AnalPower_par%n4
    AnalPower_par%n5_out=AnalPower_par%n5

    AnalPower_par%o1_out=AnalPower_par%o1
    AnalPower_par%o2_out=AnalPower_par%o2
    AnalPower_par%o3_out=AnalPower_par%o3
    AnalPower_par%o4_out=AnalPower_par%o4
    AnalPower_par%o5_out=AnalPower_par%o5

    AnalPower_par%d1_out=AnalPower_par%d1
    AnalPower_par%d2_out=AnalPower_par%d2
    AnalPower_par%d3_out=AnalPower_par%d3
    AnalPower_par%d4_out=AnalPower_par%d4
    AnalPower_par%d5_out=AnalPower_par%d5

    AnalPower_par%oper_type='none'
    call from_param('oper_type',AnalPower_par%oper_type, &
           trim(AnalPower_par%oper_type))

    select case (AnalPower_par%oper_type(1:4))
    case ('grad')
       AnalPower_par%oper_type(1:8)='gradient'
    case ('dire')
       AnalPower_par%oper_type(1:9)='direction'
    case ('corr')
       AnalPower_par%oper_type(1:18)='correlation shifts'
    case default
       write(0,*)'AnalPower_par-oper_type=',trim(AnalPower_par%oper_type)
       call seperr('Not supported oper_type')
    end select
    if(AnalPower_par%verb) then
      write(0,*)'AnalPower_par-oper_type=',trim(AnalPower_par%oper_type)
    end if
  
    select case (AnalPower_par%oper_type(1:4))
    case ('grad','dire','corr')
    !{
      call to_history("n1",AnalPower_par%n1_out)
      call to_history("n2",AnalPower_par%n2_out)
      call to_history("n3",AnalPower_par%n3_out)
      call to_history("n4",AnalPower_par%n4_out)
      call to_history("n5",AnalPower_par%n5_out)
  
      call to_history("o1",AnalPower_par%o1_out)
      call to_history("o2",AnalPower_par%o2_out)
      call to_history("o3",AnalPower_par%o3_out)
      call to_history("o4",AnalPower_par%o4_out)
      call to_history("o5",AnalPower_par%o5_out)
  
      call to_history("d1",AnalPower_par%d1_out)
      call to_history("d2",AnalPower_par%d2_out)
      call to_history("d3",AnalPower_par%d3_out)
      call to_history("d4",AnalPower_par%d4_out)
      call to_history("d5",AnalPower_par%d5_out)
    case default
       write(0,*)'AnalPower_par-oper_type=',trim(AnalPower_par%oper_type)
       call seperr('Not supported oper_type')
    end select
  
    select case (AnalPower_par%oper_type(1:4))
    case ('grad')
    !{
      call to_history("title","Gradient")
      AnalPower_par%esize_out = 8
      call to_history("esize",AnalPower_par%esize_out)
    !}
    case ('dire')
    !{
      call to_history("title","Direction error in degrees")
      AnalPower_par%esize_out = 4
      call to_history("esize",AnalPower_par%esize_out)
    !}
    case ('corr')
    !{
      AnalPower_par%rmo_type='none'
      call from_param('rmo_type',AnalPower_par%rmo_type)
      select case (AnalPower_par%rmo_type(1:3))
      case ('tay')
         AnalPower_par%rmo_type(1:6)='taylor'
      case ('ort')
         AnalPower_par%rmo_type(1:10)='orthogonal'
      case default
         write(0,*)'AnalPower_par-rmo_type=',trim(AnalPower_par%rmo_type)
         call seperr('Not supported rmo_type')
      end select
      if(AnalPower_par%verb) then
        write(0,*)'AnalPower_par-rmo_type=',trim(AnalPower_par%rmo_type)
      end if

      call from_param('max_apert',AnalPower_par%max_apert)
      call from_param('n_gamma',AnalPower_par%n_gamma)
      call from_param('gamma_0',AnalPower_par%gamma_0)
      call from_param('d_gamma',AnalPower_par%d_gamma)

      call to_history("title","Correlation shifts")
      AnalPower_par%esize_out = 4
      call to_history("esize",AnalPower_par%esize_out)
    !}
    case default
       write(0,*)'AnalPower_par-oper_type=',trim(AnalPower_par%oper_type)
       call seperr('Not supported oper_type')
    end select

  return

end subroutine param_AnalPower
